#ifndef _DCOMPARABLE_H
#define _DCOMPARABLE_H

//==============================================================================
//
// DComparable - the protocol for classes that can be compared with other class instances
//
//               Copyright (C) 2003  Dick van Oudheusden
//  
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2008-07-19 12:28:59 $ $Revision: 1.4 $
//
//==============================================================================

// The DComparable protocol specifies methods for classes that can compare the
// contents of the instance with the contents of another instance. For example
// the objects of the string class are compared during storing in a dictionary.
// See @class(DText) and @class(DAvlTree).

@protocol DComparable

//
// Compares the contents of two objects
//
// @param other    the other object (!= nil)
// 
// @return the comparison result (-1 = smaller, 0 = equal, 1 = bigger)
//

- (int) compare :(id) other;

@end

#endif

