#ifndef _DDATABLE_H
#define _DDATABLE_H

//==============================================================================
//
//      DDatable - the protocol for classes that export their state in data
//
//               Copyright (C) 2003  Dick van Oudheusden
//  
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2008-07-19 12:28:59 $ $Revision: 1.4 $
//
//==============================================================================

// The DDatable protocol specifies methods for retrieving data from an object. For
// example the prototype is used to calculate a hash value for DDatable classes.

@class DData;

@protocol DDatable

//
// Convert to a data string
//
// @return a (new) data string
//
- (DData *) toData;

@end

#endif

