#ifndef _DLOG_H
#define _DLOG_H

// This file was automatically generated by objch.

//==============================================================================
//
//        DLog - the singleton logger module in the ofc-library
//
//               Copyright (C) 2004  Dick van Oudheusden
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2004/11/23 20:06:33 $ $Revision: 1.2 $
//
//==============================================================================

#include "ofc/config.h"

#include "ofc/DLogger.h"

//
// Perfom logging of an event
// 
// @param level     the level of the event
// @param message   the message for the event
// 
// 
extern void dlog(int level, const char *message, ...);

//
// Set the mask for the level
// 
// @param levels    the bitwise ored levels
//
// @return the previous mask
// 

extern int dlogmask(int levels);

//
// Set the range for the level
// 
// @param high      the highest level to be masked
// @param low       the lowest level to be masked
// 
// @return the previous mask
// 
extern int dlogrange(int high, int low);

//
// Set the active logger
// 
// @param logger    the active logger (or nil for disable)
// 
// @return the previous logger
// 
extern id<DLogger> dlogger(id<DLogger> logger);

#endif
