#ifndef _DOBJCTOKENIZER_H
#define _DOBJCTOKENIZER_H

// This file was automatically generated by objch.

//==============================================================================
//
//     DObjcTokenizer - the Objective-C tokenizer class in the ofc-library
//
//               Copyright (C) 2005  Dick van Oudheusden
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2008-08-24 05:37:06 $ $Revision: 1.16 $
//
//==============================================================================

#include "ofc/config.h"

#include "ofc/DSource.h"

#include "ofc/DText.h"
#include "ofc/DList.h"

#include "ofc/DTextReadable.h"


// General tokens
#define DOT_UNKNOWN          (100) // Unknown token
#define DOT_EOFF             (101) // End Of File
#define DOT_EOFL             (102) // End Of Line
#define DOT_WHITESPACE       (103) // White space
#define DOT_COMMENT          (104) // Comment
#define DOT_IDENTIFIER       (105) // Identifier
#define DOT_OPERATOR         (106) // General operator
#define DOT_PREPROCESSOR     (107) // General Preprocessor

// Constants
#define DOT_DEC_NUMBER       (200) // Decimal number
#define DOT_OCT_NUMBER       (201) // Octal number
#define DOT_HEX_NUMBER       (202) // Hex number
#define DOT_FLP_NUMBER       (203) // Floating point number
#define DOT_CHAR             (204) // Character constant
#define DOT_STRING           (205) // String
#define DOT_WIDE_CHAR        (206) // Wide character constant
#define DOT_WIDE_STRING      (207) // Wide string
#define DOT_OBJC_STRING      (208) // Objective-c string

// Preprocessor subtokens
#define DOT_PASSERT          (300) // the assert directive
#define DOT_PDEFINE          (301) // the define directive
#define DOT_PELIF            (302) // the else if directive
#define DOT_PELSE            (303) // the else directive
#define DOT_PENDIF           (304) // the endif directive
#define DOT_PERROR           (305) // the error directive
#define DOT_PIDENT           (306) // the ident directive
#define DOT_PIF              (307) // the if directive
#define DOT_PIFDEF           (308) // the ifdef directive
#define DOT_PIFNDEF          (309) // the ifndef directive
#define DOT_PINCLUDE         (310) // the file include directive
#define DOT_PIMPORT          (311) // the import directive
#define DOT_PLINE            (312) // the line directive
#define DOT_PPRAGMA          (313) // the pragma directive
#define DOT_PUNASSERT        (314) // the unassert directive
#define DOT_PUNDEF           (315) // the undefine directive
#define DOT_PWARNING         (316) // the warning directive

// Predefined types subtokens
#define DOT_TCHAR            (400) // the char type
#define DOT_TDOUBLE          (401) // the double type
#define DOT_TFLOAT           (402) // the float type
#define DOT_TINT             (403) // the integer type
#define DOT_TSHORT           (404) // the short type
#define DOT_TLONG            (405) // the long type
#define DOT_TUNSIGNED        (406) // the unsigned type
#define DOT_TVOID            (407) // the void type
#define DOT_TSIGNED          (408) // the signed type

// Storage subtokens
#define DOT_AUTO             (450) // the auto keyword
#define DOT_CONST            (451) // the const keyword
#define DOT_EXTERN           (452) // the extern keyword
#define DOT_REGISTER         (453) // the register keyword
#define DOT_STATIC           (454) // the static keyword
#define DOT_VOLATILE         (455) // the volatile keyword

// Type definition subtokens
#define DOT_ENUM             (480) // the enum keyword
#define DOT_STRUCT           (481) // the struct keyword
#define DOT_TYPEDEF          (482) // the typedef keyword
#define DOT_UNION            (483) // the union keyword

// Flow subtokens
#define DOT_BREAK            (500) // the break keyword
#define DOT_CASE             (501) // the case keyword
#define DOT_CONTINUE         (502) // the continue keyword
#define DOT_DEFAULT          (503) // the default keyword
#define DOT_DO               (504) // the do keyword
#define DOT_ELSE             (505) // the else keyword
#define DOT_FOR              (506) // the for keyword
#define DOT_GOTO             (507) // the goto keyword
#define DOT_IF               (508) // the if keyword
#define DOT_RETURN           (509) // the return keyword
#define DOT_SWITCH           (510) // the switch keyword
#define DOT_WHILE            (511) // the while keyword

// Objective-C keywords
#define DOT_INTERFACE        (530) // the @interface keyword
#define DOT_IMPLEMENTATION   (531) // the @implementation keyword
#define DOT_PROTOCOL         (532) // the @protocol keyword
#define DOT_END              (533) // the @end keyword
#define DOT_PRIVATE          (534) // the @private keyword
#define DOT_PROTECTED        (535) // the @protected keyword
#define DOT_PUBLIC           (536) // the @public keyword
#define DOT_SELECTOR         (537) // the @selector keyword
#define DOT_CLASS            (538) // the @class keyword
#define DOT_ENCODE           (539) // the @encode keyword
#define DOT_DEFS             (540) // the @defs keyword
#define DOT_TRY              (541) // the @try keyword
#define DOT_CATCH            (542) // the @catch keyword
#define DOT_FINALLY          (543) // the @finally keyword
#define DOT_THROW            (544) // the @throw keyword
#define DOT_SYNCHRONIZED     (545) // the @synchronized keyword
#define DOT_SYNCHRONIZE      (546) // the @synchronize keyword

// Logical operators
#define DOT_AND              (601) // the && operator
#define DOT_OR               (602) // the || operator
#define DOT_NOT              (603) // the ! operator

// Comparison operators
#define DOT_SMALLER          (620) // the < operator
#define DOT_SMALLER_EQUAL    (621) // the <= operator
#define DOT_GREATER          (622) // the > operator
#define DOT_GREATER_EQUAL    (623) // the >= operator
#define DOT_EQUAL            (624) // the == operator
#define DOT_NOT_EQUAL        (625) // the != operator

// Bitwise operators
#define DOT_BIT_AND          (640) // the & operator
#define DOT_BIT_OR           (641) // the | operator
#define DOT_BIT_XOR          (642) // the ^ operator
#define DOT_BIT_NOT          (643) // the ~ operator
#define DOT_BIT_LEFT         (644) // the << operator
#define DOT_BIT_RIGHT        (645) // the >> operator

// General operators
#define DOT_COLON            (660) // the : operator
#define DOT_SEMI_COLON       (661) // the ; delimiter
#define DOT_COMMA            (662) // the , delimiter
#define DOT_BLOCK_OPEN       (663) // the { delimiter
#define DOT_BLOCK_CLOSE      (664) // the } delimiter
#define DOT_RBRACKET_OPEN    (665) // the ( delimiter
#define DOT_RBRACKET_CLOSE   (666) // the ) delimiter
#define DOT_SBRACKET_OPEN    (667) // the [ delimiter
#define DOT_SBRACKET_CLOSE   (668) // the ] delimiter
#define DOT_DEREFERNCE       (669) // the -> operator
#define DOT_FIELD            (670) // the . operator
#define DOT_CONDITION        (671) // the ? operator
#define DOT_SIZEOF           (672) // the sizeof operator
#define DOT_ADDRESSOF        (DOT_BIT_AND) // the & operator
#define DOT_VAR_ARG          (673) // the ... operator
#define DOT_PCONCAT          (674) // the ## operator
#define DOT_PSTRINGIFY       (675) // the # operator

// Assignment operators
#define DOT_ASSIGNMENT       (700) // the = operator
#define DOT_PLUS_ASSIGNMENT  (701) // the += operator
#define DOT_MINUS_ASSIGNMENT (702) // the -= operator
#define DOT_MULT_ASSIGNMENT  (703) // the *= operator
#define DOT_DIV_ASSIGNMENT   (704) // the /= operator
#define DOT_REM_ASSIGNMENT   (705) // the %= operator
#define DOT_LEFT_ASSIGNMENT  (706) // the <<= operator
#define DOT_RIGHT_ASSIGNMENT (707) // the >>= operator
#define DOT_AND_ASSIGNMENT   (708) // the &= operator
#define DOT_XOR_ASSIGNMENT   (709) // the ^= operator
#define DOT_OR_ASSIGNMENT    (710) // the |= operator

// Arithmetic operators
#define DOT_INCREMENT        (720) // the ++ operator
#define DOT_DECREMENT        (721) // the -- operator
#define DOT_PLUS             (722) // the + operator
#define DOT_MINUS            (723) // the - operator
#define DOT_STAR             (724) // the * operator
#define DOT_VALUEOF          (725) // the * operator
#define DOT_DIVISION         (726) // the / operator
#define DOT_REMAINDER        (727) // the % operator



//
// The class DObjcTokenizer implements an Objective-C lexical scanner. The 
// tokenizer scans a text stream for whitespace, strings, keywords, 
// comments, operators, numbers, predefined types, names, character constants,
// etc. There are two methods: nextToken and checkToken. The first method checks
// for a token and if there is a match, the scanner location is moved to
// the next location in the source. The second method only returns 
// the result of the match, the client must call the 'next' method to move the 
// scanner location.
//
// @example
// #include <stdio.h>
// #include "ofc/DObjcTokenizer.h"
// #include "ofc/DFile.h"
// 
// int main(int argc, char *argv[])
// {
//   DObjcTokenizer *src  = [DObjcTokenizer new];
//   DFile          *file = [DFile          new];
// 
//   if ([file open :"DObjcTokenizer_exp.m" :"r"])
//   {
//     if ([src source :file :"DObjcTokenizer_exp.m"])
//     {
//       [src skipWhiteSpace :YES];       // Set: skip whitespace
// 
//       while (![src isEof])
//       {
//         int token = [src nextToken];   // Scan all tokens in the file
// 
//         if ([DObjcTokenizer isLogicalOperator :token])
//         {
//           printf("Logical operator: %s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isComparisonOperator :token])
//         {
//           printf("Comparison operator: %s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isBitOperator :token])
//         {
//           printf("Bit operator:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isAssignmentOperator :token])
//         {
//           printf("Assignment operator:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isArithmeticOperator :token])
//         {
//           printf("Arithmetic operator:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isOperator :token])
//         {
//           printf("Operator:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isPredefinedTypeKeyword :token])
//         {
//           printf("Predefined type:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isStorageKeyword :token])
//         {
//           printf("Storage:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isTypeDefinitionKeyword :token])
//         {
//           printf("Typedefinition:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isFlowKeyword :token])
//         {
//           printf("Flow keyword:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isObjcKeyword :token])
//         {
//           printf("Objc-keyword:%s\n", [src text]);
//         }
//         else if ([DObjcTokenizer isDirective :token])
//         {
//           printf("Directive:%s\n", [src text]);
//         }
//         else
//           printf("Token:%d Text:%s\n", token, [src text]);
//       }
//     }
//     else
//       printf("File \"DObjcTokenizer_exp.m\" could not be used for the objc-tokenizer.\n");
// 
//     [file close];
//   }
//   else
//     printf("File \"DObjcTokenizer_exp.m\" could not be opened:%d.\n", [file error]);
// 
//   [file free];                         // Cleanup
//   [src  free];
// 
//   return 0;
// }
// 

@interface DObjcTokenizer : Object
{
@private
  DList       *_sources;        // the stack with the sources
  DSource     *_source;         // the source for the tokenizer
  
  DText       *_text;           // the last scanned, processed text
  DText       *_raw;            // the last scanned, unprocessed text
  BOOL         _eoff;           // is end of file reached ?
  BOOL         _eofl;           // is end of line reached ?
  BOOL         _sofl;           // is start of line active ?
  BOOL         _comment;        // is (block) comment active ?
  
  unsigned     _scanned;        // the length of the scanned text

  BOOL         _skipWhiteSpace; // should whitespace be skipped ? (def. YES)
  
  const
  char        *_scanLine;       // the current line for the scanner
  int          _currIndex;      // the current index in the scanner line
  int          _nextIndex;      // the next index in the scanner line
  int          _thrdIndex;      // the third index in the scanner line
  char         _currChar;       // the current character from the scanner line
  char         _nextChar;       // the next character from the scanner line
  char         _thrdChar;       // the third character from the scanner line
  BOOL         _currEsc;        // is the current character escaped ?
  BOOL         _nextEsc;        // is the next character escaped ?
  BOOL         _thrdEsc;        // is the third character escaped ?
}

//// Constructors

//
// Initialise a tokenizer
//
// @return the object
//
- (DObjcTokenizer *) init;

//
// Initialise a tokenizer with a file
//
// @param source   the source
// @param name     the name for the source
// 
// @return the object
//
- (DObjcTokenizer *) init :(id <DTextReadable>) source :(const char *) name;


//// Copy related methods

// 
// Do a shallow copy of the object (not implemented)
//
// @return the object
//
- shallowCopy;


//// Deconstructor

//
// Free the tokenizer (but *NOT* the TextReadables)
//
// @return the object
//
- free;


//// Class methods

//
// Return the text for an operator
// 
// @param token     the operator token
// 
// @return the text for the operator (or NULL)
// 
+ (const char *) operator :(int) token;

//
// Check if the token is a logical operator token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isLogicalOperator :(int) token;

//
// Check if the token is a comparison operator token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isComparisonOperator :(int) token;

//
// Check if the token is a logical operator token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isBitOperator :(int) token;

//
// Check if the token is an assignment operator token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isAssignmentOperator :(int) token;

//
// Check if the token is an assignment operator token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isArithmeticOperator :(int) token;

//
// Check if the token is an operator token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isOperator :(int) token;

//
// Return the text for a keyword token
// 
// @param token     the keyword token
// 
// @return the text for the keyword (or NULL)
// 
+ (const char *) keyword :(int) token;

//
// Return the text for an Objective-c keyword
// 
// @param token   the keyword
// 
// @return the text for the keyword (or NULL)
// 
+ (const char *) objcKeyword :(int) token;

//
// Check if the token is a predefined type keyword token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isPredefinedTypeKeyword :(int) token;

//
// Check if the token is a storage keyword token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isStorageKeyword :(int) token;

//
// Check if the token is a type definition keyword token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isTypeDefinitionKeyword :(int) token;

//
// Check if the token is a flow keyword token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isFlowKeyword :(int) token;

//
// Check if the token is a keyword token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isKeyword :(int) token;

//
// Check if the token is an objective-c keyword token
// 
// @param token     the token
// 
// @return is it?
// 
+ (BOOL) isObjcKeyword :(int) token;

//
// Return the text for a (preprocessor) directive token
//
// @param token     the directive token
// 
// @return the text for the directive (or NULL)
// 
+ (const char *) directive :(int) token;

//
// Check if the token is a (preprocessor) directive token
//
// @param token     the token
// 
// @return is it ?
// 
+ (BOOL) isDirective :(int) token;


//// Member methods

//
// Get the last scanned and processed text
// 
// @return the last scanned text (or NULL)
// 
- (const char *) text;

//
// Get the last scanned and unprocessed text
// 
// @return the last unprocessed text (or NULL)
// 
- (const char *) raw;

//
// Get the name of the current file
// 
// @return the name of the file (or NULL)
// 
- (const char *) name;

//
// Get the current line number
//
// @return the current line number
//
- (int) lineNumber;

//
// Get the current column number
//
// @return the current column number
//
- (int) columnNumber;

//
// Is the end of file reached ?
// 
// @return is it ?
// 
- (BOOL) isEof;

//
// Return whether white space is be skipped 
// 
// @return is it ?
// 
- (BOOL) skipWhiteSpace;

//
// Set whether white space should be skipped
// 
// @param skip          should white space be skipped
// 
// @return the object
// 
- (DObjcTokenizer *) skipWhiteSpace :(BOOL) skip;


//// Source methods

//
// Start using a source (an already open source is pushed on the sources stack)
// 
// @param source   the source
// @param name     the name for the source
// 
// @return success
// 
- (BOOL) source :(id <DTextReadable>) source :(const char *) name;

//
// Pop a source from the sources stack
// 
// @return success
// 
- (BOOL) popSource;


//// Scanner methods

//
// Scan the source for the next token (white space is skipped if
// this is active)
// 
// @return the next token
// 
- (int) nextToken ;

//
// Check the source for the next token (white space is not skipped)
//
// @return the scanned token
// 
- (int) checkToken;

//
// Move the scanned indicator after a checkToken method
// 
// @return the object
// 
- (DObjcTokenizer *) next ;


//// Error methods

//
// Generate an error on stderr for the current file and line
// 
// @param msg      the error message
// 
// @return the object
// 
- (DObjcTokenizer *) error :(const char *) msg;


//// Basic scanner methods (private methods)

//
// Scan the next character
// 
// @return the scanned character
// 
- (char) _scanNext;

//
// Initialise the low level scanner
// 
// @return the (first) scanned character
// 
- (char) _scanInit;

//
// Move the scanned indicator a number of positions (private)
//
// @param positions  the number of position to move
//  
// @return the object
// 
- (DObjcTokenizer *) _next :(unsigned) positions;

//
// Scan for a number
// 
// @return the token 
// 
- (int) _scanNumber;

@end
#endif
