#ifndef _DTEXTFILTERABLE_H
#define _DTEXTFILTERABLE_H

//==============================================================================
//
//     DTextFilterable - the protocol for classes that filter texts
//
//               Copyright (C) 2004  Dick van Oudheusden
//  
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2008-07-19 12:28:59 $ $Revision: 1.2 $
//
//==============================================================================

//
// The DTextFilterable protocol specifies methods for classes that implements
// text filters. This protocol is used by @class(DDirectory) to filter filenames.
// 


@protocol DTextFilterable

//
// Check if the text is accepted by the filter.
// 
// @param text         the text to be checked
// 
// @return is it accepted ?
// 

- (BOOL) accept :(const char *) text;

@end

#endif

