#ifndef _CONFIG_H
#define _CONFIG_H

//==============================================================================
//
//          config - the configuration include file for objc-site
//
//               Copyright (C) 2002  Dick van Oudheusden
//  
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//==============================================================================
// 
//  $Date: 2008-07-19 12:28:59 $ $Revision: 1.12 $
//
//==============================================================================

#include "ofc/settings.h"

// gcc
#include <objc/Object.h>
#include <objc/objc-api.h>


#ifndef EOS
  #define EOS '\0'
#endif

#ifndef NULL
  #ifdef __null
    #define NULL __null
  #else
    #define NULL ((void *) 0)
  #endif
#endif

#ifndef offsetof
  #define offsetof(type,member)   ((size_t) &((type *) 0)->member)
#endif


// missing error codes
#ifndef ENODATA
  #define ENODATA 61
#endif

// warnings
#if ENABLE_WARNINGS != 0
  #include "ofc/warning.h"

  #ifdef __GNUC__
    #define WARNING(warn,param)  warning(__PRETTY_FUNCTION__,__LINE__,warn,param)
  #else
    #define WARNING(warn,param) warning(__FILE__,__LINE__,warn,param)
  #endif

#else
  #define WARNING(warn,param)
#endif


// defines for the objch tool
#define _INTERFACE_ (0)
#define _PRIVATE_   (1)

#endif

